# core/service/rss.py
#
#

""" rss module. """

__copyright__ = "Copyright 2014 B.H.J Thate"

## IMPORTS

from core.utils import parse_urls, short_date, fetch_url, error
from core.object import Object
from core.looper import Looper
from core import kernel

import threading
import logging
import socket
import time

## DEFINES

seen = []
on_start = True

## display function

def display(*args, **kwargs):
    entry = args[0]
    result = "%s  %s" % (entry["title"], entry["link"])
    kernel.announce(result)

## look function

def rss_poll(*args, **kwargs):
    global on_start
    import core.contrib.feedparser as fp
    for obj in kernel.objects():
        if "rss" not in obj: continue
        logging.info("looking %s" % obj["rss"])
        try: data = fetch_url("GET", obj.rss).read()
        except socket.error: continue
        try: data = fp.parse(data)
        except Exception as ex: error() ; continue
        for entry in data["entries"]:
            if entry["link"] in seen: continue
            else:
                seen.append(entry["link"])
                if not on_start: display(entry)
                continue
    on_start = False

## INIT

def init(*args, **kwargs):
    global kernel
    rss = Looper(rss_poll, 600)
    kernel.run.rss = rss
    kernel.workers.put(rss.start)
